Loading...
Searching...
No Matches
juce::LookAndFeel_V2 Class Reference

## Detailed Description

This LookAndFeel subclass implements the juce style from around 2008-12.

See also
  LookAndFeel, LookAndFeel_V1, LookAndFeel_V3

The documentation for this class was generated from the following file:

- juce_gui_basics/lookandfeel/juce_LookAndFeel_V2.h

Inheritance diagram for juce::LookAndFeel_V2:

## Public Member Functions

| LookAndFeel_V2 ()
| ~LookAndFeel_V2 () override
void | drawButtonBackground (Graphics &, Button &, const Colour &backgroundColour, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
Font | getTextButtonFont (TextButton &, int buttonHeight) override
void | drawButtonText (Graphics &, TextButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws the text for a TextButton.
int | getTextButtonWidthToFitText (TextButton &, int buttonHeight) override
void | drawToggleButton (Graphics &, ToggleButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws the contents of a standard ToggleButton.
void | changeToggleButtonWidthToFitText (ToggleButton &) override
void | drawTickBox (Graphics &, Component &, float x, float y, float w, float h, bool ticked, bool isEnabled, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
void | drawDrawableButton (Graphics &, DrawableButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
AlertWindow * | createAlertWindow (const String &title, const String &message, const String &button1, const String &button2, const String &button3, MessageBoxIconType iconType, int numButtons, Component *associatedComponent) override
void | drawAlertBox (Graphics &, AlertWindow &, const Rectangle< int > &textArea, TextLayout &) override
int | getAlertBoxWindowFlags () override
Array< int > | getWidthsForTextButtons (AlertWindow &, const Array< TextButton * > &) override
int | getAlertWindowButtonHeight () override
Font | getAlertWindowTitleFont () override
| Override this function to supply a custom font for the alert window title.
Font | getAlertWindowMessageFont () override
| Override this function to supply a custom font for the alert window message.
Font | getAlertWindowFont () override
void | drawProgressBar (Graphics &, ProgressBar &, int width, int height, double progress, const String &textToShow) override
| Draws a progress bar.
void | drawSpinningWaitAnimation (Graphics &, const Colour &colour, int x, int y, int w, int h) override
| Draws a small image that spins to indicate that something's happening.
bool | isProgressBarOpaque (ProgressBar &) override
ProgressBar::Style | getDefaultProgressBarStyle (const ProgressBar &) override
| Returns the default style a progress bar should use if one hasn't been set.
bool | areScrollbarButtonsVisible () override
void | drawScrollbarButton (Graphics &, ScrollBar &, int width, int height, int buttonDirection, bool isScrollbarVertical, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws one of the buttons on a scrollbar.
void | drawScrollbar (Graphics &, ScrollBar &, int x, int y, int width, int height, bool isScrollbarVertical, int thumbStartPosition, int thumbSize, bool isMouseOver, bool isMouseDown) override
| Draws the thumb area of a scrollbar.
ImageEffectFilter * | getScrollbarEffect () override
| Returns the component effect to use for a scrollbar.
int | getMinimumScrollbarThumbSize (ScrollBar &) override
| Returns the minimum length in pixels to use for a scrollbar thumb.
int | getDefaultScrollbarWidth () override
| Returns the default thickness to use for a scrollbar.
int | getScrollbarButtonSize (ScrollBar &) override
| Returns the length in pixels to use for a scrollbar button.
Path | getTickShape (float height) override
| Returns a tick shape for use in yes/no boxes, etc.
Path | getCrossShape (float height) override
| Returns a cross shape for use in yes/no boxes, etc.
void | drawTreeviewPlusMinusBox (Graphics &, const Rectangle< float > &area, Colour backgroundColour, bool isOpen, bool isMouseOver) override
bool | areLinesDrawnForTreeView (TreeView &) override
int | getTreeViewIndentSize (TreeView &) override
void | fillTextEditorBackground (Graphics &, int width, int height, TextEditor &) override
void | drawTextEditorOutline (Graphics &, int width, int height, TextEditor &) override
CaretComponent * | createCaretComponent (Component *keyFocusOwner) override
const Drawable * | getDefaultFolderImage () override
const Drawable * | getDefaultDocumentFileImage () override
AttributedString | createFileChooserHeaderText (const String &title, const String &instructions) override
void | drawFileBrowserRow (Graphics &, int width, int height, const File &file, const String &filename, Image *icon, const String &fileSizeDescription, const String &fileTimeDescription, bool isDirectory, bool isItemSelected, int itemIndex, DirectoryContentsDisplayComponent &) override
Button * | createFileBrowserGoUpButton () override
void | layoutFileBrowserComponent (FileBrowserComponent &, DirectoryContentsDisplayComponent *, FilePreviewComponent *, ComboBox *currentPathBox, TextEditor *filenameBox, Button *goUpButton) override
void | drawBubble (Graphics &, BubbleComponent &, const Point< float > &tip, const Rectangle< float > &body) override
| Override this method to draw a speech-bubble pointing at a specific location on the screen.
void | setComponentEffectForBubbleComponent (BubbleComponent &bubbleComponent) override
| Override this method to set effects, such as a drop-shadow, on a BubbleComponent.
void | drawLasso (Graphics &, Component &) override
void | drawPopupMenuBackground (Graphics &, int width, int height) override
| Fills the background of a popup menu component.
void | drawPopupMenuBackgroundWithOptions (Graphics &, int width, int height, const PopupMenu::Options &) override
| Fills the background of a popup menu component.
void | drawPopupMenuItem (Graphics &, const Rectangle< int > &area, bool isSeparator, bool isActive, bool isHighlighted, bool isTicked, bool hasSubMenu, const String &text, const String &shortcutKeyText, const Drawable *icon, const Colour *textColour) override
| Draws one of the items in a popup menu.
void | drawPopupMenuItemWithOptions (Graphics &, const Rectangle< int > &area, bool isHighlighted, const PopupMenu::Item &item, const PopupMenu::Options &) override
| Draws one of the items in a popup menu.
void | drawPopupMenuSectionHeader (Graphics &, const Rectangle< int > &area, const String &sectionName) override
void | drawPopupMenuSectionHeaderWithOptions (Graphics &, const Rectangle< int > &area, const String &sectionName, const PopupMenu::Options &) override
Font | getPopupMenuFont () override
| Returns the size and style of font to use in popup menus.
void | drawPopupMenuUpDownArrow (Graphics &, int width, int height, bool isScrollUpArrow) override
void | drawPopupMenuUpDownArrowWithOptions (Graphics &, int width, int height, bool isScrollUpArrow, const PopupMenu::Options &) override
void | getIdealPopupMenuItemSize (const String &text, bool isSeparator, int standardMenuItemHeight, int &idealWidth, int &idealHeight) override
| Finds the best size for an item in a popup menu.
void | getIdealPopupMenuItemSizeWithOptions (const String &text, bool isSeparator, int standardMenuItemHeight, int &idealWidth, int &idealHeight, const PopupMenu::Options &) override
| Finds the best size for an item in a popup menu.
void | getIdealPopupMenuSectionHeaderSizeWithOptions (const String &text, int standardMenuItemHeight, int &idealWidth, int &idealHeight, const PopupMenu::Options &) override
int | getMenuWindowFlags () override
void | preparePopupMenuWindow (Component &) override
void | drawMenuBarBackground (Graphics &, int width, int height, bool isMouseOverBar, MenuBarComponent &) override
int | getMenuBarItemWidth (MenuBarComponent &, int itemIndex, const String &itemText) override
Font | getMenuBarFont (MenuBarComponent &, int itemIndex, const String &itemText) override
int | getDefaultMenuBarHeight () override
void | drawMenuBarItem (Graphics &, int width, int height, int itemIndex, const String &itemText, bool isMouseOverItem, bool isMenuOpen, bool isMouseOverBar, MenuBarComponent &) override
Component * | getParentComponentForMenuOptions (const PopupMenu::Options &options) override
bool | shouldPopupMenuScaleWithTargetComponent (const PopupMenu::Options &options) override
| Return true if you want your popup menus to scale with the target component's AffineTransform or scale factor.
int | getPopupMenuBorderSize () override
int | getPopupMenuBorderSizeWithOptions (const PopupMenu::Options &) override
void | drawPopupMenuColumnSeparatorWithOptions (Graphics &g, const Rectangle< int > &bounds, const PopupMenu::Options &) override
| Implement this to draw some custom decoration between the columns of the popup menu.
int | getPopupMenuColumnSeparatorWidthWithOptions (const PopupMenu::Options &) override
| Return the amount of space that should be left between popup menu columns.
void | drawComboBox (Graphics &, int width, int height, bool isMouseButtonDown, int buttonX, int buttonY, int buttonW, int buttonH, ComboBox &) override
Font | getComboBoxFont (ComboBox &) override
Label * | createComboBoxTextBox (ComboBox &) override
void | positionComboBoxText (ComboBox &, Label &) override
PopupMenu::Options | getOptionsForComboBoxPopupMenu (ComboBox &, Label &) override
void | drawComboBoxTextWhenNothingSelected (Graphics &, ComboBox &, Label &) override
void | drawLabel (Graphics &, Label &) override
Font | getLabelFont (Label &) override
BorderSize< int > | getLabelBorderSize (Label &) override
void | drawLinearSlider (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, Slider::SliderStyle, Slider &) override
void | drawLinearSliderBackground (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, Slider::SliderStyle, Slider &) override
void | drawLinearSliderOutline (Graphics &, int x, int y, int width, int height, Slider::SliderStyle, Slider &) override
void | drawLinearSliderThumb (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, Slider::SliderStyle, Slider &) override
void | drawRotarySlider (Graphics &, int x, int y, int width, int height, float sliderPosProportional, float rotaryStartAngle, float rotaryEndAngle, Slider &) override
int | getSliderThumbRadius (Slider &) override
Button * | createSliderButton (Slider &, bool isIncrement) override
Label * | createSliderTextBox (Slider &) override
ImageEffectFilter * | getSliderEffect (Slider &) override
Font | getSliderPopupFont (Slider &) override
int | getSliderPopupPlacement (Slider &) override
Slider::SliderLayout | getSliderLayout (Slider &) override
Rectangle< int > | getTooltipBounds (const String &tipText, Point< int > screenPos, Rectangle< int > parentArea) override
| returns the bounds for a tooltip at the given screen coordinate, constrained within the given desktop area.
void | drawTooltip (Graphics &, const String &text, int width, int height) override
Button * | createFilenameComponentBrowseButton (const String &text) override
void | layoutFilenameComponent (FilenameComponent &, ComboBox *filenameBox, Button *browseButton) override
void | drawConcertinaPanelHeader (Graphics &, const Rectangle< int > &area, bool isMouseOver, bool isMouseDown, ConcertinaPanel &, Component &panel) override
void | drawCornerResizer (Graphics &, int w, int h, bool isMouseOver, bool isMouseDragging) override
void | drawResizableFrame (Graphics &, int w, int h, const BorderSize< int > &) override
void | fillResizableWindowBackground (Graphics &, int w, int h, const BorderSize< int > &, ResizableWindow &) override
void | drawResizableWindowBorder (Graphics &, int w, int h, const BorderSize< int > &border, ResizableWindow &) override
void | drawDocumentWindowTitleBar (DocumentWindow &, Graphics &, int w, int h, int titleSpaceX, int titleSpaceW, const Image *icon, bool drawTitleTextOnLeft) override
Button * | createDocumentWindowButton (int buttonType) override
void | positionDocumentWindowButtons (DocumentWindow &, int titleBarX, int titleBarY, int titleBarW, int titleBarH, Button *minimiseButton, Button *maximiseButton, Button *closeButton, bool positionTitleBarButtonsOnLeft) override
std::unique_ptr< DropShadower > | createDropShadowerForComponent (Component &) override
| Creates a drop-shadower for a given component, if required.
std::unique_ptr< FocusOutline > | createFocusOutlineForComponent (Component &) override
| Creates a focus outline for a given component, if required.
void | drawStretchableLayoutResizerBar (Graphics &, int w, int h, bool isVerticalBar, bool isMouseOver, bool isMouseDragging) override
void | drawGroupComponentOutline (Graphics &, int w, int h, const String &text, const Justification &, GroupComponent &) override
int | getTabButtonSpaceAroundImage () override
int | getTabButtonOverlap (int tabDepth) override
int | getTabButtonBestWidth (TabBarButton &, int tabDepth) override
Rectangle< int > | getTabButtonExtraComponentBounds (const TabBarButton &, Rectangle< int > &textArea, Component &extraComp) override
void | drawTabButton (TabBarButton &, Graphics &, bool isMouseOver, bool isMouseDown) override
Font | getTabButtonFont (TabBarButton &, float height) override
void | drawTabButtonText (TabBarButton &, Graphics &, bool isMouseOver, bool isMouseDown) override
void | drawTabbedButtonBarBackground (TabbedButtonBar &, Graphics &) override
void | drawTabAreaBehindFrontButton (TabbedButtonBar &, Graphics &, int w, int h) override
void | createTabButtonShape (TabBarButton &, Path &, bool isMouseOver, bool isMouseDown) override
void | fillTabButtonShape (TabBarButton &, Graphics &, const Path &, bool isMouseOver, bool isMouseDown) override
Button * | createTabBarExtrasButton () override
void | drawImageButton (Graphics &, Image *, int imageX, int imageY, int imageW, int imageH, const Colour &overlayColour, float imageOpacity, ImageButton &) override
void | drawTableHeaderBackground (Graphics &, TableHeaderComponent &) override
void | drawTableHeaderColumn (Graphics &, TableHeaderComponent &, const String &columnName, int columnId, int width, int height, bool isMouseOver, bool isMouseDown, int columnFlags) override
void | paintToolbarBackground (Graphics &, int width, int height, Toolbar &) override
Button * | createToolbarMissingItemsButton (Toolbar &) override
void | paintToolbarButtonBackground (Graphics &, int width, int height, bool isMouseOver, bool isMouseDown, ToolbarItemComponent &) override
void | paintToolbarButtonLabel (Graphics &, int x, int y, int width, int height, const String &text, ToolbarItemComponent &) override
void | drawPropertyPanelSectionHeader (Graphics &, const String &name, bool isOpen, int width, int height) override
void | drawPropertyComponentBackground (Graphics &, int width, int height, PropertyComponent &) override
void | drawPropertyComponentLabel (Graphics &, int width, int height, PropertyComponent &) override
Rectangle< int > | getPropertyComponentContentPosition (PropertyComponent &) override
int | getPropertyPanelSectionHeaderHeight (const String &sectionTitle) override
void | drawCallOutBoxBackground (CallOutBox &, Graphics &, const Path &path, Image &cachedImage) override
int | getCallOutBoxBorderSize (const CallOutBox &) override
float | getCallOutBoxCornerSize (const CallOutBox &) override
void | drawLevelMeter (Graphics &, int width, int height, float level) override
void | drawKeymapChangeButton (Graphics &, int width, int height, Button &, const String &keyDescription) override
Font | getSidePanelTitleFont (SidePanel &) override
Justification | getSidePanelTitleJustification (SidePanel &) override
Path | getSidePanelDismissButtonShape (SidePanel &) override
Public Member Functions inherited from juce::LookAndFeel
| LookAndFeel ()
| Creates the default JUCE look and feel.
| ~LookAndFeel () override
| Destructor.
Colour | findColour (int colourId) const noexcept
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourId, Colour colour) noexcept
| Registers a colour to be used for a particular purpose.
bool | isColourSpecified (int colourId) const noexcept
| Returns true if the specified colour ID has been explicitly set using the setColour() method.
virtual Typeface::Ptr | getTypefaceForFont (const Font &)
| Returns the typeface that should be used for a given font.
virtual TypefaceMetricsKind | getDefaultMetricsKind () const
| Widgets can call this to find out the kind of metrics they should use when creating their own fonts.
FontOptions | withDefaultMetrics (FontOptions opt) const
| Returns a copy of the FontOptions with the LookAndFeel's default metrics kind set.
void | setDefaultSansSerifTypeface (Typeface::Ptr newDefaultTypeface)
| Allows you to supply a default typeface that will be returned as the default sans-serif font.
void | setDefaultSansSerifTypefaceName (const String &newName)
| Allows you to change the default sans-serif font.
void | setUsingNativeAlertWindows (bool shouldUseNativeAlerts)
| Sets whether native alert windows (if available) or standard JUCE AlertWindows drawn with AlertWindow::LookAndFeelMethods will be used.
bool | isUsingNativeAlertWindows ()
| Returns true if native alert windows will be used (if available).
virtual MouseCursor | getMouseCursorFor (Component &)
| Override this to get the chance to swap a component's mouse cursor for a customised one.
virtual std::unique_ptr< LowLevelGraphicsContext > | createGraphicsContext (const Image &imageToRenderOn, Point< int > origin, const RectangleList< int > &initialClip)
| Creates a new graphics context object.
virtual void | playAlertSound ()
| Plays the system's default 'beep' noise, to alert the user about something very important.
Public Member Functions inherited from juce::ScrollBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::Button::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::ImageButton::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::TextEditor::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::FileBrowserComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::TreeView::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::BubbleComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::AlertWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::PopupMenu::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::ComboBox::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::Label::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::Slider::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::ResizableWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::DocumentWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::TooltipWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::TabbedButtonBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::PropertyComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::FilenameComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::GroupComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::TableHeaderComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::CallOutBox::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::Toolbar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::ConcertinaPanel::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::ProgressBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::StretchableLayoutResizerBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from juce::ExtraLookAndFeelBaseClasses::KeyMappingEditorComponentMethods
virtual | ~KeyMappingEditorComponentMethods ()=default
Public Member Functions inherited from juce::ExtraLookAndFeelBaseClasses::AudioDeviceSelectorComponentMethods
virtual | ~AudioDeviceSelectorComponentMethods ()=default
Public Member Functions inherited from juce::ExtraLookAndFeelBaseClasses::LassoComponentMethods
virtual | ~LassoComponentMethods ()=default
Public Member Functions inherited from juce::SidePanel::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default

## Static Public Member Functions

static void | drawBevel (Graphics &, int x, int y, int width, int height, int bevelThickness, const Colour &topLeftColour=Colours::white, const Colour &bottomRightColour=Colours::black, bool useGradient=true, bool sharpEdgeOnOutside=true)
| Draws a 3D raised (or indented) bevel using two colours.
static void | drawGlassSphere (Graphics &, float x, float y, float diameter, const Colour &, float outlineThickness) noexcept
| Utility function to draw a shiny, glassy circle (for round LED-type buttons).
static void | drawGlassPointer (Graphics &, float x, float y, float diameter, const Colour &, float outlineThickness, int direction) noexcept
static void | drawGlassLozenge (Graphics &, float x, float y, float width, float height, const Colour &, float outlineThickness, float cornerSize, bool flatOnLeft, bool flatOnRight, bool flatOnTop, bool flatOnBottom) noexcept
| Utility function to draw a shiny, glassy oblong (for text buttons).
Static Public Member Functions inherited from juce::LookAndFeel
static LookAndFeel & | getDefaultLookAndFeel () noexcept
| Returns the current default look-and-feel for a component to use when it hasn't got one explicitly set.
static void | setDefaultLookAndFeel (LookAndFeel *newDefaultLookAndFeel) noexcept
| Changes the default look-and-feel.

## Constructors and Destructors

## LookAndFeel_V2()

juce::LookAndFeel_V2::LookAndFeel_V2 | ( |  | ) |

Referenced by drawGlassLozenge().

## ~LookAndFeel_V2()

juce::LookAndFeel_V2::~LookAndFeel_V2 | ( |  | ) |

override

## Member Functions

## drawButtonBackground()

void juce::LookAndFeel_V2::drawButtonBackground | ( | Graphics & | ,
|  | Button & | ,
|  | const Colour & | backgroundColour,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown )

override virtual

Implements juce::Button::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3, and juce::LookAndFeel_V4.

## getTextButtonFont()

Font juce::LookAndFeel_V2::getTextButtonFont | ( | TextButton & | ,
|  | int | buttonHeight )

override virtual

Implements juce::Button::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## drawButtonText()

void juce::LookAndFeel_V2::drawButtonText | ( | Graphics & | ,
|  | TextButton & | ,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown )

override virtual

Draws the text for a TextButton.

Implements juce::Button::LookAndFeelMethods.

## getTextButtonWidthToFitText()

int juce::LookAndFeel_V2::getTextButtonWidthToFitText | ( | TextButton & | ,
|  | int | buttonHeight )

override virtual

Implements juce::Button::LookAndFeelMethods.

## drawToggleButton()

void juce::LookAndFeel_V2::drawToggleButton | ( | Graphics & | ,
|  | ToggleButton & | ,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown )

override virtual

Draws the contents of a standard ToggleButton.

Implements juce::Button::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## changeToggleButtonWidthToFitText()

void juce::LookAndFeel_V2::changeToggleButtonWidthToFitText | ( | ToggleButton & |  | ) |

override virtual

Implements juce::Button::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## drawTickBox()

void juce::LookAndFeel_V2::drawTickBox | ( | Graphics & | ,
|  | Component & | ,
|  | float | x,
|  | float | y,
|  | float | w,
|  | float | h,
|  | bool | ticked,
|  | bool | isEnabled,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown )

override virtual

Implements juce::Button::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

References h, w, x, and y.

## drawDrawableButton()

void juce::LookAndFeel_V2::drawDrawableButton | ( | Graphics & | ,
|  | DrawableButton & | ,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown )

override virtual

Implements juce::Button::LookAndFeelMethods.

## createAlertWindow()

AlertWindow * juce::LookAndFeel_V2::createAlertWindow | ( | const String & | title,
|  | const String & | message,
|  | const String & | button1,
|  | const String & | button2,
|  | const String & | button3,
|  | MessageBoxIconType | iconType,
|  | int | numButtons,
|  | Component * | associatedComponent )

override virtual

Implements juce::AlertWindow::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## drawAlertBox()

void juce::LookAndFeel_V2::drawAlertBox | ( | Graphics & | ,
|  | AlertWindow & | ,
|  | const Rectangle< int > & | textArea,
|  | TextLayout & | )

override virtual

Implements juce::AlertWindow::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getAlertBoxWindowFlags()

int juce::LookAndFeel_V2::getAlertBoxWindowFlags | ( |  | ) |

override virtual

Implements juce::AlertWindow::LookAndFeelMethods.

## getWidthsForTextButtons()

Array< int > juce::LookAndFeel_V2::getWidthsForTextButtons | ( | AlertWindow & | ,
|  | const Array< TextButton * > & | )

override virtual

Implements juce::AlertWindow::LookAndFeelMethods.

## getAlertWindowButtonHeight()

int juce::LookAndFeel_V2::getAlertWindowButtonHeight | ( |  | ) |

override virtual

Implements juce::AlertWindow::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getAlertWindowTitleFont()

Font juce::LookAndFeel_V2::getAlertWindowTitleFont | ( |  | ) |

override virtual

Override this function to supply a custom font for the alert window title.

This default implementation will use a boldened and slightly larger version of the alert window message font.

See also
  getAlertWindowMessageFont.

Implements juce::AlertWindow::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getAlertWindowMessageFont()

Font juce::LookAndFeel_V2::getAlertWindowMessageFont | ( |  | ) |

override virtual

Override this function to supply a custom font for the alert window message.

This default implementation will use the default font with height set to 15.0f.

See also
  getAlertWindowTitleFont

Implements juce::AlertWindow::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getAlertWindowFont()

Font juce::LookAndFeel_V2::getAlertWindowFont | ( |  | ) |

override virtual

Implements juce::AlertWindow::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## drawProgressBar()

void juce::LookAndFeel_V2::drawProgressBar | ( | Graphics & | ,
|  | ProgressBar & | ,
|  | int | width,
|  | int | height,
|  | double | progress,
|  | const String & | textToShow )

override virtual

Draws a progress bar.

If the progress value is less than 0 or greater than 1.0, this should draw a spinning bar that fills the whole space (i.e. to say that the app is still busy but the progress isn't known). It can use the current time as a basis for playing an animation.

To determine which style of progress-bar to draw call getResolvedStyle().

(Used by progress bars in AlertWindow).

See also
  getResolvedStyle

Implements juce::ProgressBar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## drawSpinningWaitAnimation()

void juce::LookAndFeel_V2::drawSpinningWaitAnimation | ( | Graphics & | ,
|  | const Colour & | colour,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h )

override virtual

Draws a small image that spins to indicate that something's happening.

This method should use the current time to animate itself, so just keep repainting it every so often.

Implements juce::LookAndFeel.

References h, w, x, and y.

## isProgressBarOpaque()

bool juce::LookAndFeel_V2::isProgressBarOpaque | ( | ProgressBar & |  | ) |

override virtual

Implements juce::ProgressBar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getDefaultProgressBarStyle()

ProgressBar::Style juce::LookAndFeel_V2::getDefaultProgressBarStyle | ( | const ProgressBar & |  | ) |

override virtual

Returns the default style a progress bar should use if one hasn't been set.

See also
  setStyle, getResolvedStyle

Implements juce::ProgressBar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## areScrollbarButtonsVisible()

bool juce::LookAndFeel_V2::areScrollbarButtonsVisible | ( |  | ) |

override virtual

Implements juce::ScrollBar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3.

## drawScrollbarButton()

void juce::LookAndFeel_V2::drawScrollbarButton | ( | Graphics & | g,
|  | ScrollBar & | scrollbar,
|  | int | width,
|  | int | height,
|  | int | buttonDirection,
|  | bool | isScrollbarVertical,
|  | bool | isMouseOverButton,
|  | bool | isButtonDown )

override virtual

Draws one of the buttons on a scrollbar.

Parameters

  g | the context to draw into
  scrollbar | the bar itself
  width | the width of the button
  height | the height of the button
  buttonDirection | the direction of the button, where 0 = up, 1 = right, 2 = down, 3 = left
  isScrollbarVertical | true if it's a vertical bar, false if horizontal
  isMouseOverButton | whether the mouse is currently over the button (also true if it's held down)
  isButtonDown | whether the mouse button's held down

Implements juce::ScrollBar::LookAndFeelMethods.

## drawScrollbar()

void juce::LookAndFeel_V2::drawScrollbar | ( | Graphics & | g,
|  | ScrollBar & | scrollbar,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | bool | isScrollbarVertical,
|  | int | thumbStartPosition,
|  | int | thumbSize,
|  | bool | isMouseOver,
|  | bool | isMouseDown )

override virtual

Draws the thumb area of a scrollbar.

Parameters

  g | the context to draw into
  scrollbar | the bar itself
  x | the x position of the left edge of the thumb area to draw in
  y | the y position of the top edge of the thumb area to draw in
  width | the width of the thumb area to draw in
  height | the height of the thumb area to draw in
  isScrollbarVertical | true if it's a vertical bar, false if horizontal
  thumbStartPosition | for vertical bars, the y coordinate of the top of the thumb, or its x position for horizontal bars
  thumbSize | for vertical bars, the height of the thumb, or its width for horizontal bars. This may be 0 if the thumb shouldn't be drawn.
  isMouseOver | whether the mouse is over the thumb area, also true if the mouse is currently dragging the thumb
  isMouseDown | whether the mouse is currently dragging the scrollbar

Implements juce::ScrollBar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3, and juce::LookAndFeel_V4.

References x, and y.

## getScrollbarEffect()

ImageEffectFilter * juce::LookAndFeel_V2::getScrollbarEffect | ( |  | ) |

override virtual

Returns the component effect to use for a scrollbar.

Implements juce::ScrollBar::LookAndFeelMethods.

## getMinimumScrollbarThumbSize()

int juce::LookAndFeel_V2::getMinimumScrollbarThumbSize | ( | ScrollBar & |  | ) |

override virtual

Returns the minimum length in pixels to use for a scrollbar thumb.

Implements juce::ScrollBar::LookAndFeelMethods.

## getDefaultScrollbarWidth()

int juce::LookAndFeel_V2::getDefaultScrollbarWidth | ( |  | ) |

override virtual

Returns the default thickness to use for a scrollbar.

Implements juce::ScrollBar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getScrollbarButtonSize()

int juce::LookAndFeel_V2::getScrollbarButtonSize | ( | ScrollBar & |  | ) |

override virtual

Returns the length in pixels to use for a scrollbar button.

Implements juce::ScrollBar::LookAndFeelMethods.

## getTickShape()

Path juce::LookAndFeel_V2::getTickShape | ( | float | height | ) |

override virtual

Returns a tick shape for use in yes/no boxes, etc.

Implements juce::LookAndFeel.

Reimplemented in juce::LookAndFeel_V3, and juce::LookAndFeel_V4.

## getCrossShape()

Path juce::LookAndFeel_V2::getCrossShape | ( | float | height | ) |

override virtual

Returns a cross shape for use in yes/no boxes, etc.

Implements juce::LookAndFeel.

Reimplemented in juce::LookAndFeel_V3, and juce::LookAndFeel_V4.

## drawTreeviewPlusMinusBox()

void juce::LookAndFeel_V2::drawTreeviewPlusMinusBox | ( | Graphics & | ,
|  | const Rectangle< float > & | area,
|  | Colour | backgroundColour,
|  | bool | isOpen,
|  | bool | isMouseOver )

override virtual

Implements juce::TreeView::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3.

## areLinesDrawnForTreeView()

bool juce::LookAndFeel_V2::areLinesDrawnForTreeView | ( | TreeView & |  | ) |

override virtual

Implements juce::TreeView::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3.

## getTreeViewIndentSize()

int juce::LookAndFeel_V2::getTreeViewIndentSize | ( | TreeView & |  | ) |

override virtual

Implements juce::TreeView::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3.

## fillTextEditorBackground()

void juce::LookAndFeel_V2::fillTextEditorBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | TextEditor & | )

override virtual

Implements juce::TextEditor::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## drawTextEditorOutline()

void juce::LookAndFeel_V2::drawTextEditorOutline | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | TextEditor & | )

override virtual

Implements juce::TextEditor::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3, and juce::LookAndFeel_V4.

## createCaretComponent()

CaretComponent * juce::LookAndFeel_V2::createCaretComponent | ( | Component * | keyFocusOwner | ) |

override virtual

Implements juce::TextEditor::LookAndFeelMethods.

## getDefaultFolderImage()

const Drawable * juce::LookAndFeel_V2::getDefaultFolderImage | ( |  | ) |

override virtual

Implements juce::FileBrowserComponent::LookAndFeelMethods.

## getDefaultDocumentFileImage()

const Drawable * juce::LookAndFeel_V2::getDefaultDocumentFileImage | ( |  | ) |

override virtual

Implements juce::FileBrowserComponent::LookAndFeelMethods.

## createFileChooserHeaderText()

AttributedString juce::LookAndFeel_V2::createFileChooserHeaderText | ( | const String & | title,
|  | const String & | instructions )

override virtual

Implements juce::FileBrowserComponent::LookAndFeelMethods.

## drawFileBrowserRow()

void juce::LookAndFeel_V2::drawFileBrowserRow | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | const File & | file,
|  | const String & | filename,
|  | Image * | icon,
|  | const String & | fileSizeDescription,
|  | const String & | fileTimeDescription,
|  | bool | isDirectory,
|  | bool | isItemSelected,
|  | int | itemIndex,
|  | DirectoryContentsDisplayComponent & | )

override virtual

Implements juce::FileBrowserComponent::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## createFileBrowserGoUpButton()

Button * juce::LookAndFeel_V2::createFileBrowserGoUpButton | ( |  | ) |

override virtual

Implements juce::FileBrowserComponent::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## layoutFileBrowserComponent()

void juce::LookAndFeel_V2::layoutFileBrowserComponent | ( | FileBrowserComponent & | ,
|  | DirectoryContentsDisplayComponent * | ,
|  | FilePreviewComponent * | ,
|  | ComboBox * | currentPathBox,
|  | TextEditor * | filenameBox,
|  | Button * | goUpButton )

override virtual

Implements juce::FileBrowserComponent::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## drawBubble()

void juce::LookAndFeel_V2::drawBubble | ( | Graphics & | g,
|  | BubbleComponent & | bubbleComponent,
|  | const Point< float > & | positionOfTip,
|  | const Rectangle< float > & | body )

override virtual

Override this method to draw a speech-bubble pointing at a specific location on the screen.

Implements juce::BubbleComponent::LookAndFeelMethods.

## setComponentEffectForBubbleComponent()

void juce::LookAndFeel_V2::setComponentEffectForBubbleComponent | ( | BubbleComponent & | bubbleComponent | ) |

override virtual

Override this method to set effects, such as a drop-shadow, on a BubbleComponent.

This will be called whenever a BubbleComponent is constructed or its look-and-feel changes.

If you need to trigger this callback to update an effect, call sendLookAndFeelChange() on the component.

See also
  Component::setComponentEffect, Component::sendLookAndFeelChange

Implements juce::BubbleComponent::LookAndFeelMethods.

## drawLasso()

void juce::LookAndFeel_V2::drawLasso | ( | Graphics & | ,
|  | Component & | )

override virtual

Implements juce::ExtraLookAndFeelBaseClasses::LassoComponentMethods.

## drawPopupMenuBackground()

void juce::LookAndFeel_V2::drawPopupMenuBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height )

override virtual

Fills the background of a popup menu component.

Reimplemented from juce::PopupMenu::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3.

## drawPopupMenuBackgroundWithOptions()

void juce::LookAndFeel_V2::drawPopupMenuBackgroundWithOptions | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | const PopupMenu::Options & | )

override virtual

Fills the background of a popup menu component.

Implements juce::PopupMenu::LookAndFeelMethods.

## drawPopupMenuItem()

void juce::LookAndFeel_V2::drawPopupMenuItem | ( | Graphics & | ,
|  | const Rectangle< int > & | area,
|  | bool | isSeparator,
|  | bool | isActive,
|  | bool | isHighlighted,
|  | bool | isTicked,
|  | bool | hasSubMenu,
|  | const String & | text,
|  | const String & | shortcutKeyText,
|  | const Drawable * | icon,
|  | const Colour * | textColour )

override virtual

Draws one of the items in a popup menu.

Reimplemented from juce::PopupMenu::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## drawPopupMenuItemWithOptions()

void juce::LookAndFeel_V2::drawPopupMenuItemWithOptions | ( | Graphics & | ,
|  | const Rectangle< int > & | area,
|  | bool | isHighlighted,
|  | const PopupMenu::Item & | item,
|  | const PopupMenu::Options & | )

override virtual

Draws one of the items in a popup menu.

Implements juce::PopupMenu::LookAndFeelMethods.

## drawPopupMenuSectionHeader()

void juce::LookAndFeel_V2::drawPopupMenuSectionHeader | ( | Graphics & | ,
|  | const Rectangle< int > & | area,
|  | const String & | sectionName )

override virtual

Reimplemented from juce::PopupMenu::LookAndFeelMethods.

## drawPopupMenuSectionHeaderWithOptions()

void juce::LookAndFeel_V2::drawPopupMenuSectionHeaderWithOptions | ( | Graphics & | ,
|  | const Rectangle< int > & | area,
|  | const String & | sectionName,
|  | const PopupMenu::Options & | )

override virtual

Implements juce::PopupMenu::LookAndFeelMethods.

## getPopupMenuFont()

Font juce::LookAndFeel_V2::getPopupMenuFont | ( |  | ) |

override virtual

Returns the size and style of font to use in popup menus.

Implements juce::PopupMenu::LookAndFeelMethods.

## drawPopupMenuUpDownArrow()

void juce::LookAndFeel_V2::drawPopupMenuUpDownArrow | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isScrollUpArrow )

override virtual

Reimplemented from juce::PopupMenu::LookAndFeelMethods.

## drawPopupMenuUpDownArrowWithOptions()

void juce::LookAndFeel_V2::drawPopupMenuUpDownArrowWithOptions | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isScrollUpArrow,
|  | const PopupMenu::Options & | )

override virtual

Implements juce::PopupMenu::LookAndFeelMethods.

## getIdealPopupMenuItemSize()

void juce::LookAndFeel_V2::getIdealPopupMenuItemSize | ( | const String & | text,
|  | bool | isSeparator,
|  | int | standardMenuItemHeight,
|  | int & | idealWidth,
|  | int & | idealHeight )

override virtual

Finds the best size for an item in a popup menu.

Reimplemented from juce::PopupMenu::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getIdealPopupMenuItemSizeWithOptions()

void juce::LookAndFeel_V2::getIdealPopupMenuItemSizeWithOptions | ( | const String & | text,
|  | bool | isSeparator,
|  | int | standardMenuItemHeight,
|  | int & | idealWidth,
|  | int & | idealHeight,
|  | const PopupMenu::Options & | )

override virtual

Finds the best size for an item in a popup menu.

Implements juce::PopupMenu::LookAndFeelMethods.

## getIdealPopupMenuSectionHeaderSizeWithOptions()

void juce::LookAndFeel_V2::getIdealPopupMenuSectionHeaderSizeWithOptions | ( | const String & | text,
|  | int | standardMenuItemHeight,
|  | int & | idealWidth,
|  | int & | idealHeight,
|  | const PopupMenu::Options & | )

override virtual

Implements juce::PopupMenu::LookAndFeelMethods.

## getMenuWindowFlags()

int juce::LookAndFeel_V2::getMenuWindowFlags | ( |  | ) |

override virtual

Implements juce::PopupMenu::LookAndFeelMethods.

## preparePopupMenuWindow()

void juce::LookAndFeel_V2::preparePopupMenuWindow | ( | Component & |  | ) |

override virtual

Implements juce::PopupMenu::LookAndFeelMethods.

## drawMenuBarBackground()

void juce::LookAndFeel_V2::drawMenuBarBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isMouseOverBar,
|  | MenuBarComponent & | )

override virtual

Implements juce::PopupMenu::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3, and juce::LookAndFeel_V4.

## getMenuBarItemWidth()

int juce::LookAndFeel_V2::getMenuBarItemWidth | ( | MenuBarComponent & | ,
|  | int | itemIndex,
|  | const String & | itemText )

override virtual

Implements juce::PopupMenu::LookAndFeelMethods.

## getMenuBarFont()

Font juce::LookAndFeel_V2::getMenuBarFont | ( | MenuBarComponent & | ,
|  | int | itemIndex,
|  | const String & | itemText )

override virtual

Implements juce::PopupMenu::LookAndFeelMethods.

## getDefaultMenuBarHeight()

int juce::LookAndFeel_V2::getDefaultMenuBarHeight | ( |  | ) |

override virtual

Implements juce::PopupMenu::LookAndFeelMethods.

## drawMenuBarItem()

void juce::LookAndFeel_V2::drawMenuBarItem | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | int | itemIndex,
|  | const String & | itemText,
|  | bool | isMouseOverItem,
|  | bool | isMenuOpen,
|  | bool | isMouseOverBar,
|  | MenuBarComponent & | )

override virtual

Implements juce::PopupMenu::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getParentComponentForMenuOptions()

Component * juce::LookAndFeel_V2::getParentComponentForMenuOptions | ( | const PopupMenu::Options & | options | ) |

override virtual

Implements juce::PopupMenu::LookAndFeelMethods.

## shouldPopupMenuScaleWithTargetComponent()

bool juce::LookAndFeel_V2::shouldPopupMenuScaleWithTargetComponent | ( | const PopupMenu::Options & | options | ) |

override virtual

Return true if you want your popup menus to scale with the target component's AffineTransform or scale factor.

Implements juce::PopupMenu::LookAndFeelMethods.

## getPopupMenuBorderSize()

int juce::LookAndFeel_V2::getPopupMenuBorderSize | ( |  | ) |

override virtual

Reimplemented from juce::PopupMenu::LookAndFeelMethods.

## getPopupMenuBorderSizeWithOptions()

int juce::LookAndFeel_V2::getPopupMenuBorderSizeWithOptions | ( | const PopupMenu::Options & |  | ) |

override virtual

Implements juce::PopupMenu::LookAndFeelMethods.

## drawPopupMenuColumnSeparatorWithOptions()

void juce::LookAndFeel_V2::drawPopupMenuColumnSeparatorWithOptions | ( | Graphics & | g,
|  | const Rectangle< int > & | bounds,
|  | const PopupMenu::Options & | )

override virtual

Implement this to draw some custom decoration between the columns of the popup menu.

getPopupMenuColumnSeparatorWidthWithOptions must return a positive value in order to display the separator.

Implements juce::PopupMenu::LookAndFeelMethods.

## getPopupMenuColumnSeparatorWidthWithOptions()

int juce::LookAndFeel_V2::getPopupMenuColumnSeparatorWidthWithOptions | ( | const PopupMenu::Options & |  | ) |

override virtual

Return the amount of space that should be left between popup menu columns.

Implements juce::PopupMenu::LookAndFeelMethods.

## drawComboBox()

void juce::LookAndFeel_V2::drawComboBox | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isMouseButtonDown,
|  | int | buttonX,
|  | int | buttonY,
|  | int | buttonW,
|  | int | buttonH,
|  | ComboBox & | )

override virtual

Implements juce::ComboBox::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3, and juce::LookAndFeel_V4.

## getComboBoxFont()

Font juce::LookAndFeel_V2::getComboBoxFont | ( | ComboBox & |  | ) |

override virtual

Implements juce::ComboBox::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## createComboBoxTextBox()

Label * juce::LookAndFeel_V2::createComboBoxTextBox | ( | ComboBox & |  | ) |

override virtual

Implements juce::ComboBox::LookAndFeelMethods.

## positionComboBoxText()

void juce::LookAndFeel_V2::positionComboBoxText | ( | ComboBox & | ,
|  | Label & | )

override virtual

Implements juce::ComboBox::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getOptionsForComboBoxPopupMenu()

PopupMenu::Options juce::LookAndFeel_V2::getOptionsForComboBoxPopupMenu | ( | ComboBox & | ,
|  | Label & | )

override virtual

Implements juce::ComboBox::LookAndFeelMethods.

## drawComboBoxTextWhenNothingSelected()

void juce::LookAndFeel_V2::drawComboBoxTextWhenNothingSelected | ( | Graphics & | ,
|  | ComboBox & | ,
|  | Label & | )

override virtual

Implements juce::ComboBox::LookAndFeelMethods.

## drawLabel()

void juce::LookAndFeel_V2::drawLabel | ( | Graphics & | ,
|  | Label & | )

override virtual

Implements juce::Label::LookAndFeelMethods.

## getLabelFont()

Font juce::LookAndFeel_V2::getLabelFont | ( | Label & |  | ) |

override virtual

Implements juce::Label::LookAndFeelMethods.

## getLabelBorderSize()

BorderSize< int > juce::LookAndFeel_V2::getLabelBorderSize | ( | Label & |  | ) |

override virtual

Implements juce::Label::LookAndFeelMethods.

## drawLinearSlider()

void juce::LookAndFeel_V2::drawLinearSlider | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | float | sliderPos,
|  | float | minSliderPos,
|  | float | maxSliderPos,
|  | Slider::SliderStyle | ,
|  | Slider & | )

override virtual

Implements juce::Slider::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3, and juce::LookAndFeel_V4.

References x, and y.

## drawLinearSliderBackground()

void juce::LookAndFeel_V2::drawLinearSliderBackground | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | float | sliderPos,
|  | float | minSliderPos,
|  | float | maxSliderPos,
|  | Slider::SliderStyle | ,
|  | Slider & | )

override virtual

Implements juce::Slider::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3.

References x, and y.

## drawLinearSliderOutline()

void juce::LookAndFeel_V2::drawLinearSliderOutline | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | Slider::SliderStyle | ,
|  | Slider & | )

override virtual

Implements juce::Slider::LookAndFeelMethods.

References x, and y.

## drawLinearSliderThumb()

void juce::LookAndFeel_V2::drawLinearSliderThumb | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | float | sliderPos,
|  | float | minSliderPos,
|  | float | maxSliderPos,
|  | Slider::SliderStyle | ,
|  | Slider & | )

override virtual

Implements juce::Slider::LookAndFeelMethods.

References x, and y.

## drawRotarySlider()

void juce::LookAndFeel_V2::drawRotarySlider | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | float | sliderPosProportional,
|  | float | rotaryStartAngle,
|  | float | rotaryEndAngle,
|  | Slider & | )

override virtual

Implements juce::Slider::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

References x, and y.

## getSliderThumbRadius()

int juce::LookAndFeel_V2::getSliderThumbRadius | ( | Slider & |  | ) |

override virtual

Implements juce::Slider::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## createSliderButton()

Button * juce::LookAndFeel_V2::createSliderButton | ( | Slider & | ,
|  | bool | isIncrement )

override virtual

Implements juce::Slider::LookAndFeelMethods.

## createSliderTextBox()

Label * juce::LookAndFeel_V2::createSliderTextBox | ( | Slider & |  | ) |

override virtual

Implements juce::Slider::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getSliderEffect()

ImageEffectFilter * juce::LookAndFeel_V2::getSliderEffect | ( | Slider & |  | ) |

override virtual

Implements juce::Slider::LookAndFeelMethods.

## getSliderPopupFont()

Font juce::LookAndFeel_V2::getSliderPopupFont | ( | Slider & |  | ) |

override virtual

Implements juce::Slider::LookAndFeelMethods.

## getSliderPopupPlacement()

int juce::LookAndFeel_V2::getSliderPopupPlacement | ( | Slider & |  | ) |

override virtual

Implements juce::Slider::LookAndFeelMethods.

## getSliderLayout()

Slider::SliderLayout juce::LookAndFeel_V2::getSliderLayout | ( | Slider & |  | ) |

override virtual

Implements juce::Slider::LookAndFeelMethods.

## getTooltipBounds()

Rectangle< int > juce::LookAndFeel_V2::getTooltipBounds | ( | const String & | tipText,
|  | Point< int > | screenPos,
|  | Rectangle< int > | parentArea )

override virtual

returns the bounds for a tooltip at the given screen coordinate, constrained within the given desktop area.

Implements juce::TooltipWindow::LookAndFeelMethods.

## drawTooltip()

void juce::LookAndFeel_V2::drawTooltip | ( | Graphics & | ,
|  | const String & | text,
|  | int | width,
|  | int | height )

override virtual

Implements juce::TooltipWindow::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## createFilenameComponentBrowseButton()

Button * juce::LookAndFeel_V2::createFilenameComponentBrowseButton | ( | const String & | text | ) |

override virtual

Implements juce::FilenameComponent::LookAndFeelMethods.

## layoutFilenameComponent()

void juce::LookAndFeel_V2::layoutFilenameComponent | ( | FilenameComponent & | ,
|  | ComboBox * | filenameBox,
|  | Button * | browseButton )

override virtual

Implements juce::FilenameComponent::LookAndFeelMethods.

## drawConcertinaPanelHeader()

void juce::LookAndFeel_V2::drawConcertinaPanelHeader | ( | Graphics & | ,
|  | const Rectangle< int > & | area,
|  | bool | isMouseOver,
|  | bool | isMouseDown,
|  | ConcertinaPanel & | ,
|  | Component & | panel )

override virtual

Implements juce::ConcertinaPanel::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3, and juce::LookAndFeel_V4.

## drawCornerResizer()

void juce::LookAndFeel_V2::drawCornerResizer | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | bool | isMouseOver,
|  | bool | isMouseDragging )

override virtual

Implements juce::ResizableWindow::LookAndFeelMethods.

References h, and w.

## drawResizableFrame()

void juce::LookAndFeel_V2::drawResizableFrame | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | const BorderSize< int > & | )

override virtual

Implements juce::ResizableWindow::LookAndFeelMethods.

References h, and w.

## fillResizableWindowBackground()

void juce::LookAndFeel_V2::fillResizableWindowBackground | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | const BorderSize< int > & | ,
|  | ResizableWindow & | )

override virtual

Implements juce::ResizableWindow::LookAndFeelMethods.

References h, and w.

## drawResizableWindowBorder()

void juce::LookAndFeel_V2::drawResizableWindowBorder | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | const BorderSize< int > & | border,
|  | ResizableWindow & | )

override virtual

Implements juce::ResizableWindow::LookAndFeelMethods.

References h, and w.

## drawDocumentWindowTitleBar()

void juce::LookAndFeel_V2::drawDocumentWindowTitleBar | ( | DocumentWindow & | ,
|  | Graphics & | ,
|  | int | w,
|  | int | h,
|  | int | titleSpaceX,
|  | int | titleSpaceW,
|  | const Image * | icon,
|  | bool | drawTitleTextOnLeft )

override virtual

Implements juce::DocumentWindow::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

References h, and w.

## createDocumentWindowButton()

Button * juce::LookAndFeel_V2::createDocumentWindowButton | ( | int | buttonType | ) |

override virtual

Implements juce::DocumentWindow::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3, and juce::LookAndFeel_V4.

## positionDocumentWindowButtons()

void juce::LookAndFeel_V2::positionDocumentWindowButtons | ( | DocumentWindow & | ,
|  | int | titleBarX,
|  | int | titleBarY,
|  | int | titleBarW,
|  | int | titleBarH,
|  | Button * | minimiseButton,
|  | Button * | maximiseButton,
|  | Button * | closeButton,
|  | bool | positionTitleBarButtonsOnLeft )

override virtual

Implements juce::DocumentWindow::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## createDropShadowerForComponent()

std::unique_ptr< DropShadower > juce::LookAndFeel_V2::createDropShadowerForComponent | ( | Component & |  | ) |

override virtual

Creates a drop-shadower for a given component, if required.

See also
  DropShadower

Implements juce::LookAndFeel.

## createFocusOutlineForComponent()

std::unique_ptr< FocusOutline > juce::LookAndFeel_V2::createFocusOutlineForComponent | ( | Component & |  | ) |

override virtual

Creates a focus outline for a given component, if required.

See also
  FocusOutline

Implements juce::LookAndFeel.

## drawStretchableLayoutResizerBar()

void juce::LookAndFeel_V2::drawStretchableLayoutResizerBar | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | bool | isVerticalBar,
|  | bool | isMouseOver,
|  | bool | isMouseDragging )

override virtual

Implements juce::StretchableLayoutResizerBar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3, and juce::LookAndFeel_V4.

References h, and w.

## drawGroupComponentOutline()

void juce::LookAndFeel_V2::drawGroupComponentOutline | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | const String & | text,
|  | const Justification & | ,
|  | GroupComponent & | )

override virtual

Implements juce::GroupComponent::LookAndFeelMethods.

References h, and w.

## getTabButtonSpaceAroundImage()

int juce::LookAndFeel_V2::getTabButtonSpaceAroundImage | ( |  | ) |

override virtual

Implements juce::TabbedButtonBar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3.

## getTabButtonOverlap()

int juce::LookAndFeel_V2::getTabButtonOverlap | ( | int | tabDepth | ) |

override virtual

Implements juce::TabbedButtonBar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3.

## getTabButtonBestWidth()

int juce::LookAndFeel_V2::getTabButtonBestWidth | ( | TabBarButton & | ,
|  | int | tabDepth )

override virtual

Implements juce::TabbedButtonBar::LookAndFeelMethods.

## getTabButtonExtraComponentBounds()

Rectangle< int > juce::LookAndFeel_V2::getTabButtonExtraComponentBounds | ( | const TabBarButton & | ,
|  | Rectangle< int > & | textArea,
|  | Component & | extraComp )

override virtual

Implements juce::TabbedButtonBar::LookAndFeelMethods.

## drawTabButton()

void juce::LookAndFeel_V2::drawTabButton | ( | TabBarButton & | ,
|  | Graphics & | ,
|  | bool | isMouseOver,
|  | bool | isMouseDown )

override virtual

Implements juce::TabbedButtonBar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3.

## getTabButtonFont()

Font juce::LookAndFeel_V2::getTabButtonFont | ( | TabBarButton & | ,
|  | float | height )

override virtual

Implements juce::TabbedButtonBar::LookAndFeelMethods.

## drawTabButtonText()

void juce::LookAndFeel_V2::drawTabButtonText | ( | TabBarButton & | ,
|  | Graphics & | ,
|  | bool | isMouseOver,
|  | bool | isMouseDown )

override virtual

Implements juce::TabbedButtonBar::LookAndFeelMethods.

## drawTabbedButtonBarBackground()

void juce::LookAndFeel_V2::drawTabbedButtonBarBackground | ( | TabbedButtonBar & | ,
|  | Graphics & | )

override virtual

Implements juce::TabbedButtonBar::LookAndFeelMethods.

## drawTabAreaBehindFrontButton()

void juce::LookAndFeel_V2::drawTabAreaBehindFrontButton | ( | TabbedButtonBar & | ,
|  | Graphics & | ,
|  | int | w,
|  | int | h )

override virtual

Implements juce::TabbedButtonBar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3.

References h, and w.

## createTabButtonShape()

void juce::LookAndFeel_V2::createTabButtonShape | ( | TabBarButton & | ,
|  | Path & | ,
|  | bool | isMouseOver,
|  | bool | isMouseDown )

override virtual

Implements juce::TabbedButtonBar::LookAndFeelMethods.

## fillTabButtonShape()

void juce::LookAndFeel_V2::fillTabButtonShape | ( | TabBarButton & | ,
|  | Graphics & | ,
|  | const Path & | ,
|  | bool | isMouseOver,
|  | bool | isMouseDown )

override virtual

Implements juce::TabbedButtonBar::LookAndFeelMethods.

## createTabBarExtrasButton()

Button * juce::LookAndFeel_V2::createTabBarExtrasButton | ( |  | ) |

override virtual

Implements juce::TabbedButtonBar::LookAndFeelMethods.

## drawImageButton()

void juce::LookAndFeel_V2::drawImageButton | ( | Graphics & | ,
|  | Image * | ,
|  | int | imageX,
|  | int | imageY,
|  | int | imageW,
|  | int | imageH,
|  | const Colour & | overlayColour,
|  | float | imageOpacity,
|  | ImageButton & | )

override virtual

Implements juce::ImageButton::LookAndFeelMethods.

## drawTableHeaderBackground()

void juce::LookAndFeel_V2::drawTableHeaderBackground | ( | Graphics & | ,
|  | TableHeaderComponent & | )

override virtual

Implements juce::TableHeaderComponent::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V3.

## drawTableHeaderColumn()

void juce::LookAndFeel_V2::drawTableHeaderColumn | ( | Graphics & | ,
|  | TableHeaderComponent & | ,
|  | const String & | columnName,
|  | int | columnId,
|  | int | width,
|  | int | height,
|  | bool | isMouseOver,
|  | bool | isMouseDown,
|  | int | columnFlags )

override virtual

Implements juce::TableHeaderComponent::LookAndFeelMethods.

## paintToolbarBackground()

void juce::LookAndFeel_V2::paintToolbarBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | Toolbar & | )

override virtual

Implements juce::Toolbar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## createToolbarMissingItemsButton()

Button * juce::LookAndFeel_V2::createToolbarMissingItemsButton | ( | Toolbar & |  | ) |

override virtual

Implements juce::Toolbar::LookAndFeelMethods.

## paintToolbarButtonBackground()

void juce::LookAndFeel_V2::paintToolbarButtonBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isMouseOver,
|  | bool | isMouseDown,
|  | ToolbarItemComponent & | )

override virtual

Implements juce::Toolbar::LookAndFeelMethods.

## paintToolbarButtonLabel()

void juce::LookAndFeel_V2::paintToolbarButtonLabel | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | const String & | text,
|  | ToolbarItemComponent & | )

override virtual

Implements juce::Toolbar::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

References x, and y.

## drawPropertyPanelSectionHeader()

void juce::LookAndFeel_V2::drawPropertyPanelSectionHeader | ( | Graphics & | ,
|  | const String & | name,
|  | bool | isOpen,
|  | int | width,
|  | int | height )

override virtual

Implements juce::PropertyComponent::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

References name.

## drawPropertyComponentBackground()

void juce::LookAndFeel_V2::drawPropertyComponentBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | PropertyComponent & | )

override virtual

Implements juce::PropertyComponent::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## drawPropertyComponentLabel()

void juce::LookAndFeel_V2::drawPropertyComponentLabel | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | PropertyComponent & | )

override virtual

Implements juce::PropertyComponent::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getPropertyComponentContentPosition()

Rectangle< int > juce::LookAndFeel_V2::getPropertyComponentContentPosition | ( | PropertyComponent & |  | ) |

override virtual

Implements juce::PropertyComponent::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getPropertyPanelSectionHeaderHeight()

int juce::LookAndFeel_V2::getPropertyPanelSectionHeaderHeight | ( | const String & | sectionTitle | ) |

override virtual

Implements juce::PropertyComponent::LookAndFeelMethods.

## drawCallOutBoxBackground()

void juce::LookAndFeel_V2::drawCallOutBoxBackground | ( | CallOutBox & | ,
|  | Graphics & | ,
|  | const Path & | path,
|  | Image & | cachedImage )

override virtual

Implements juce::CallOutBox::LookAndFeelMethods.

Reimplemented in juce::LookAndFeel_V4.

## getCallOutBoxBorderSize()

int juce::LookAndFeel_V2::getCallOutBoxBorderSize | ( | const CallOutBox & |  | ) |

override virtual

Implements juce::CallOutBox::LookAndFeelMethods.

## getCallOutBoxCornerSize()

float juce::LookAndFeel_V2::getCallOutBoxCornerSize | ( | const CallOutBox & |  | ) |

override virtual

Implements juce::CallOutBox::LookAndFeelMethods.

## drawLevelMeter()

void juce::LookAndFeel_V2::drawLevelMeter | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | float | level )

override virtual

Implements juce::ExtraLookAndFeelBaseClasses::AudioDeviceSelectorComponentMethods.

Reimplemented in juce::LookAndFeel_V4.

## drawKeymapChangeButton()

void juce::LookAndFeel_V2::drawKeymapChangeButton | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | Button & | ,
|  | const String & | keyDescription )

override virtual

Implements juce::ExtraLookAndFeelBaseClasses::KeyMappingEditorComponentMethods.

Reimplemented in juce::LookAndFeel_V3.

## getSidePanelTitleFont()

Font juce::LookAndFeel_V2::getSidePanelTitleFont | ( | SidePanel & |  | ) |

override virtual

Implements juce::SidePanel::LookAndFeelMethods.

## getSidePanelTitleJustification()

Justification juce::LookAndFeel_V2::getSidePanelTitleJustification | ( | SidePanel & |  | ) |

override virtual

Implements juce::SidePanel::LookAndFeelMethods.

## getSidePanelDismissButtonShape()

Path juce::LookAndFeel_V2::getSidePanelDismissButtonShape | ( | SidePanel & |  | ) |

override virtual

Implements juce::SidePanel::LookAndFeelMethods.

## drawBevel()

void juce::LookAndFeel_V2::drawBevel | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | int | bevelThickness,
|  | const Colour & | topLeftColour = Colours::white,
|  | const Colour & | bottomRightColour = Colours::black,
|  | bool | useGradient = true,
|  | bool | sharpEdgeOnOutside = true )

static

Draws a 3D raised (or indented) bevel using two colours.

The bevel is drawn inside the given rectangle, and greater bevel thicknesses extend inwards.

The top-left colour is used for the top- and left-hand edges of the bevel; the bottom-right colour is used for the bottom- and right-hand edges.

If useGradient is true, then the bevel fades out to make it look more curved and less angular. If sharpEdgeOnOutside is true, the outside of the bevel is sharp, and it fades towards the centre; if sharpEdgeOnOutside is false, then the centre edges are sharp and it fades towards the outside.

References juce::Colours::black, juce::Colours::white, x, and y.

## drawGlassSphere()

void juce::LookAndFeel_V2::drawGlassSphere | ( | Graphics & | ,
|  | float | x,
|  | float | y,
|  | float | diameter,
|  | const Colour & | ,
|  | float | outlineThickness )

static noexcept

Utility function to draw a shiny, glassy circle (for round LED-type buttons).

References x, and y.

## drawGlassPointer()

void juce::LookAndFeel_V2::drawGlassPointer | ( | Graphics & | ,
|  | float | x,
|  | float | y,
|  | float | diameter,
|  | const Colour & | ,
|  | float | outlineThickness,
|  | int | direction )

static noexcept

References x, and y.

## drawGlassLozenge()

void juce::LookAndFeel_V2::drawGlassLozenge | ( | Graphics & | ,
|  | float | x,
|  | float | y,
|  | float | width,
|  | float | height,
|  | const Colour & | ,
|  | float | outlineThickness,
|  | float | cornerSize,
|  | bool | flatOnLeft,
|  | bool | flatOnRight,
|  | bool | flatOnTop,
|  | bool | flatOnBottom )

static noexcept

Utility function to draw a shiny, glassy oblong (for text buttons).

References h, LookAndFeel_V2(), w, x, and y.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited